port module Cli exposing (..)

import Cbor.Tag exposing (Tag(..))
import CliTools exposing (doOnCmd, mkCLi)
import Platform exposing (worker)


version : String
version =
    "0.0.1"


versionMessage : String
versionMessage =
    version


helpMessage : String
helpMessage =
    """
cli - a cli tool in elm
  
How to build a cli tool in elm
"""


type alias Flags =
    ()


type alias Model =
    ()


type Msg
    = Args (List String)


main : Program Flags Model Msg
main =
    worker
        { init = init
        , update = update
        , subscriptions = subscriptions
        }


init : Flags -> ( Model, Cmd Msg )
init _ =
    ( (), Cmd.none )


subscriptions : Model -> Sub Msg
subscriptions _ =
    do Args


port do : (List String -> msg) -> Sub msg


port stdout : String -> Cmd msg


s : String -> ( Model, Cmd msg )
s x =
    ( (), stdout x )


update : Msg -> Model -> ( Model, Cmd Msg )
update (Args l) model =
    cli l model


cli : List String -> Model -> ( Model, Cmd Msg )
cli =
    mkCLi stdout version helpMessage dos


dos : List (List String -> Model -> Maybe ( Model, Cmd Msg ))
dos =
    [ doOnCmd "tx" doTx, doOnCmd "view" doView ]


doTx : List String -> Model -> ( Model, Cmd Msg )
doTx _ _ =
    s "doTx is not yet implemented"


doView : List String -> Model -> ( Model, Cmd Msg )
doView _ _ =
    s "doView is not yet implemented"
