module MaybeExtra exposing (justFirst, justFirstElse, justIf)


justFirst : List (a -> Maybe b) -> a -> Maybe b
justFirst l x =
    case l of
        [] ->
            Nothing

        first :: rest ->
            case first x of
                Just y ->
                    Just y

                _ ->
                    justFirst rest x


justFirstElse : List (a -> Maybe b) -> (a -> b) -> a -> b
justFirstElse l def x =
    case justFirst l x of
        Just y ->
            y

        Nothing ->
            def x


justIf : (a -> Bool) -> b -> a -> Maybe b
justIf pred y x =
    if pred x then
        Just y

    else
        Nothing
